use actix_web::{get, post, HttpResponse, Responder};

pub fn add(left: u64, right: u64) -> u64 {
    left + right
}

#[get("/")]
pub async fn hello() -> impl Responder {
    HttpResponse::Ok().body("Hello world!")
}

#[post("/echo")]
pub async fn echo(req_body: String) -> impl Responder {
    HttpResponse::Ok().body(req_body)
}

pub async fn manual_hello() -> impl Responder {
    HttpResponse::Ok().body("Hello there!\nGeneral Kenobi")
}

// the path to get to the html response
#[get("/resend")]
// function signature, data that is passed in, return type must implement the Responder trait 
pub async fn resend(req_body: String) -> impl Responder {
    // this returns a html response with a 200 code
    // this should be used for final serialization
    // possibly main functionality
    HttpResponse::Ok().body(req_body)
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn it_works() {
        let result = add(2, 2);
        assert_eq!(result, 4);
    }
}
