extern crate trpl;
use trpl::Html;

async fn main() {
    let args: Vec<String> = std::env::args().collect();
    let url = &args[1];
    match page_title(url).await {
        Some(title) => println!("The title for {url} was {title}"),
        None => println!("{url} had no title"),
    }
}

async fn page_title(url: &str) -> Option<String> {
    let res = trpl::get(url).await;

    let res_text = res.text().await;

    Html::parse(&res_text)
        .select_first("title")
        .map(|title_element| title_element.inner_html())
}
